
#ifndef NTL_vec_ZZX__H
#define NTL_vec_ZZX__H

#include <NTL/ZZX.h>
#include <NTL/vector.h>

NTL_OPEN_NNS

#if 0
NTL_vector_decl(ZZX,vec_ZZX)

NTL_eq_vector_decl(ZZX,vec_ZZX)

NTL_io_vector_decl(ZZX,vec_ZZX)
#endif

void mul(vec_ZZX& x, const vec_ZZX& a, const ZZX& b);
inline void mul(vec_ZZX& x, const ZZX& a, const vec_ZZX& b)
   { mul(x, b, a); }

void mul(vec_ZZX& x, const vec_ZZX& a, long b);
inline void mul(vec_ZZX& x, long a, const vec_ZZX& b)
   { mul(x, b, a); }

void add(vec_ZZX& x, const vec_ZZX& a, const vec_ZZX& b);

void sub(vec_ZZX& x, const vec_ZZX& a, const vec_ZZX& b);
void clear(vec_ZZX& x);



//"skalarni" soucin vektoru
void InnerProduct(ZZX& x, const vec_ZZX& a, const vec_ZZX& b);

long IsZero(const vec_ZZX& a);

vec_ZZX operator+(const vec_ZZX& a, const vec_ZZX& b);
vec_ZZX operator-(const vec_ZZX& a, const vec_ZZX& b);
vec_ZZX operator-(const vec_ZZX& a);

//vektor polynomu * polynom
inline vec_ZZX operator*(const vec_ZZX& a, const ZZX& b)
   { vec_ZZX x; mul(x, a, b); NTL_OPT_RETURN(vec_ZZX, x); }

//vektor polynomu * konstanta
inline vec_ZZX operator*(const vec_ZZX& a, long b)
   { vec_ZZX x; mul(x, a, b); NTL_OPT_RETURN(vec_ZZX, x); }

//polynom * vektor polynomu
inline vec_ZZX operator*(const ZZX& a, const vec_ZZX& b)
   { vec_ZZX x; mul(x, a, b); NTL_OPT_RETURN(vec_ZZX, x); }

//konstanta * vektor polynomu
inline vec_ZZX operator*(long a, const vec_ZZX& b)
   { vec_ZZX x; mul(x, a, b); NTL_OPT_RETURN(vec_ZZX, x); }


//vektor polynomu * vektor polynomu
ZZX operator*(const vec_ZZX& a, const vec_ZZX& b);





// assignment operator notation:

inline vec_ZZX& operator+=(vec_ZZX& x, const vec_ZZX& a)
{
   add(x, x, a);
   return x;
}

inline vec_ZZX& operator-=(vec_ZZX& x, const vec_ZZX& a)
{
   sub(x, x, a);
   return x;
}

inline vec_ZZX& operator*=(vec_ZZX& x, const ZZX& a)
{
   mul(x, x, a);
   return x;
}

inline vec_ZZX& operator*=(vec_ZZX& x, long a)
{
   mul(x, x, a);
   return x;
}

void VectorCopy(vec_ZZX& x, const vec_ZZX& a, long n);
inline vec_ZZX VectorCopy(const vec_ZZX& a, long n)
   { vec_ZZX x; VectorCopy(x, a, n); NTL_OPT_RETURN(vec_ZZX, x); }


NTL_CLOSE_NNS


#endif
